Redmine - Defect #35634

Attachments deletable even though issue edit not permitted
2021-07-29 10:26 - D G

Status: Closed Start date:

Priority: Normal Due date:

Assignee: Marius BALTEANU % Done: 0%
Category: Permissions and roles Estimated time: 0.00 hour
Target version: 4.1.5

Resolution: Fixed Affected version: 4.2.1
Description

If role A has permission to edit issues in tracker X but not in tracker Y, members of this role can delete attachments in issues with
tracker Y.

This commit fixes this for attachments_editable? r15476. Likewise this should be done in /app/models/issue.rb:

# Overrides Redmine::Acts::Attachable::InstanceMethods#attachments_deletable?
def attachments_deletable? (user=User.current)

attributes_editable? (user)
end

Associated revisions

Revision 21141 - 2021-08-06 01:48 - Marius BALTEANU

Adds tests for issue attachment edit by user without edit issue permission on tracker (#35634).

Revision 21142 - 2021-08-06 01:50 - Marius BALTEANU

Fixed attachments deletable by user without edit issue permission on tracker (#35634).

Revision 21143 - 2021-08-06 08:59 - Marius BALTEANU
Merged r21141 to 4.2-stable (#35634).

Revision 21144 - 2021-08-06 08:59 - Marius BALTEANU
Merged r21142 to 4.2-stable (#35634).

Revision 21145 - 2021-08-06 09:00 - Marius BALTEANU
Merged r21141 to 4.1-stable (#35634).

Revision 21146 - 2021-08-06 09:00 - Marius BALTEANU
Merged r21142 to 4.1-stable (#35634).

Revision 21152 - 2021-08-10 22:26 - Marius BALTEANU
Fixed "Layout/IndentationWidth: Use 2 (not 4) spaces for indentation." introduced by r21141 (#35634).

Revision 21154 - 2021-08-11 22:36 - Marius BALTEANU
Merged r21152 to 4.2-stable (#35634).

Revision 21155 - 2021-08-11 22:37 - Marius BALTEANU
Merged r21152 to 4.1-stable (#35634).

History

#1 - 2021-07-29 10:41-D G

#24623 solves this issue but does a lot more...

#2 - 2021-07-29 13:48 - Mischa The Evil

- Status changed from New to Confirmed
https://www.redmine.org/projects/redmine/repository/svn/revisions/15476
https://www.redmine.org/issues/24623

Issue and given fix confirmed. Adding the given method to Issue fixes this by properly taking tracker permissions into account (i.e. :edit_issue
permission needed for tracker Y to delete attachments attached to an issue with set tracker Y).

D G wrote:

#24623 solves this issue but does a lot more...

Indeed. It implements full CRUD-permissions for issue attachments. | think it would be nice to have it integrated into the core, however the provided
patch as-is is pretty big and, sadly, is currently outdated and will likely break the existing test suite and comes without any test coverage for the new
features itself.

I've had a quick look into the patch implementation though and it all seems properly implemented (albeit to obviously outdated checkouts). It shouldn't
be all too hard to rebase it onto the current trunk. Updating the test suite for the patch and testing (for) and handling (of) any possible edge-cases will
be most of the required work to get it ready for a decision on core integration.

#3 - 2021-08-01 12:55 - Marius BALTEANU
- Assignee set to Marius BALTEANU

- Target version set to 4.1.5

#4 - 2021-08-01 13:32 - Marius BALTEANU

I've added two patches:

e first one adds tests for r15476
e second one fixes this issue and add tests.

#5 - 2021-08-01 13:32 - Marius BALTEANU
- File 0002-Fixed-attachments-deletable-by-user-without-edit-per.patch added
- File 0001-Adds-tests-for-issue-attachment-edit-by-user-without.patch added

#6 - 2021-08-06 01:52 - Marius BALTEANU

- Status changed from Confirmed to Resolved
Patches committed.

#7 - 2021-08-06 10:05 - Marius BALTEANU
- Status changed from Resolved to Closed

- Resolution set to Fixed

Files
0002-Fixed-attachments-deletable-by-user-without-edit-per.patch 2.62 KB 2021-08-01 Marius BALTEANU
0001-Adds-tests-for-issue-attachment-edit-by-user-without.patch 2.07 KB 2021-08-01 Marius BALTEANU
